using System;
using Oracle.DataAccess.Client;
using Oracle.DataAccess.Types;
using Microsoft.Deployment.WindowsInstaller;

namespace VerifyOracle.CustomActions
{
	class VerifyOracleCredentials : CustomAction
	{
		public VerifyOracleCredentials(Session session) : base(session)		
        {
        }

        protected override ActionResult Solve()
        {
            var oracleSource = session["ORA_SERVER"];
            var oracleUserId = session["ORA_USERNAME"];
			var oraclePassword = session["ORA_PASSWORD"];
            OracleConnection con = new OracleConnection
            {
                //using connection string attributes to connect to Oracle Database
                ConnectionString = $"User Id={oracleUserId};Password={oraclePassword};Data Source={oracleSource};"
            };

            try
            {
                con.Open();
                session["ORA_CONNECTION"] = "0";
                con.Close();
            }
            catch(Exception ex)
            {
                session["ORA_CONNECTION"] = $"Connection to Oracle Database failed:{Environment.NewLine}{ex.Message}";
            }
            finally
            {
                con.Dispose();
            }

            return ActionResult.Success;
	    }
	}
}